// SetProgressHelper.js
// Version: 0.0.1
// Event: Lens Initialized
// Description: This script sets additional progress in the progress bar objects under parentObject every time setProgress() is called

//@input SceneObject parentObject
//@input vec4 newColor {"widget":"color"}
var obj = script.parentObject ? script.parentObject : script.getSceneObject();
var progressInt = 0;
var orgColor = new vec4(1,1,1,1);

function setProgress() {
    if (progressInt == obj.getChildrenCount()) {
        return;
    }
    
    for (i=0;i<obj.getChildrenCount();i++) {
        obj.getChild(progressInt).getFirstComponent("Component.Image").getMaterial(0).mainPass.baseColor = script.newColor;
    }
    progressInt ++;
}

script.api.onResponse = function() {
    reset();
};

function reset() {
    progressInt = 0;
    for (i=0;i<obj.getChildrenCount();i++) {
        obj.getChild(i).getFirstComponent("Component.Image").getMaterial(0).mainPass.baseColor = orgColor;
    }
}

script.api.setProgress = setProgress;
