// SpaceObjectCollectionHelper.js
// Version: 0.0.1
// Event: Lens Initialized
// Description: This script is attached to objects being instantiated in SpaceObjectSpawnerHelper, it indicates if this object is ready to be collected and calls collection functions from the spawner script when it's in range'


//@input Component.ScriptComponent objectSpawner
//@input Component.ScriptComponent setProgressHelper
//@input Component.Camera camera
//@input float tolerance = 0.15
//@input string playSoundTrigger

var isInRange = checkIfInCenter();

script.createEvent("TapEvent").bind(function() {
    if (checkIfInCenter()) {
        onShot.reset(0.2);
    }
    global.behaviorSystem.sendCustomTrigger(script.playSoundTrigger);
});

script.createEvent("UpdateEvent").bind(function() {
    
    if (isInRange != checkIfInCenter()) {
        isInRange = checkIfInCenter();
        script.objectSpawner.api.setFocus(isInRange); 
    }
});

var onShot = script.createEvent("DelayedCallbackEvent");
onShot.bind(function(eventData) {
    script.objectSpawner.api.collectObject();
    script.setProgressHelper.api.setProgress();
    script.objectSpawner.api.setFocus(false);
    disableSelf.reset(0.5);
});

var disableSelf = script.createEvent("DelayedCallbackEvent");
disableSelf.bind(function(eventData) {
    script.getSceneObject().destroy();
});

function checkIfInCenter() {
    var screenSpace = script.camera.worldSpaceToScreenSpace(script.getSceneObject().getTransform().getWorldPosition());
    if ((screenSpace.x > (0.5-script.tolerance)) && (screenSpace.x < (0.5+script.tolerance)) && (screenSpace.y > (0.5-script.tolerance)) && (screenSpace.y < (0.5+script.tolerance))) {
        return true;
    } else {
        return false;
    }
}