// @input Asset.ObjectPrefab objectPrefab
// SpaceObjectSpawnerHelper.js
// Version: 0.0.1
// Event: Lens Initialized
// Description: Instantiates objects and controls the collection of objects instantiated

//@input string completeTrigger
//@input int spawnAmount = 25
//@input float spawnRadius = 400
//@input int collectionAmount = 8

var triggerShooterStart = "UI_SHOOTER_START";
var triggerShooterStop = "UI_SHOOTER_STOP";

var objects = [];
var totalAmount = script.collectionAmount;
var currentAmount = 0;
var hasObjectsInFocus = false;
var spawnRadius = script.spawnRadius;


function instantiateObjects() {
    script.getSceneObject().enabled = true;
    currentAmount = 0;
    var spawnAmountDifference = script.spawnAmount - script.getSceneObject().getChildrenCount();
    for (i=0;i<spawnAmountDifference;i++) {
        var newObject = script.objectPrefab.instantiate(script.getSceneObject());
        var newPos = new vec3(Math.random()*spawnRadius - 0.5 * spawnRadius, Math.random()*spawnRadius - 0.5 * spawnRadius, Math.random()*spawnRadius - 0.5 * spawnRadius);
        newObject.getTransform().setLocalPosition(newPos);
    }
}

function onResponse() {
    instantiateObjects();
}

function collectObject() {
    currentAmount ++;
    if (currentAmount >= totalAmount) {
        global.behaviorSystem.sendCustomTrigger(script.completeTrigger);
    }
}

function setFocus(b) {
    if (hasObjectsInFocus != b) {
        hasObjectsInFocus = b;
        var trigger = b ? triggerShooterStart : triggerShooterStop;
        global.behaviorSystem.sendCustomTrigger(trigger);
    }
    
}

script.api.onResponse = onResponse;
script.api.collectObject = collectObject;
script.api.setFocus = setFocus;