// InstantParticleHelper.js
// Version: 0.0.1
// Event: Lens Initialized
// Description: This script play a particle system with external time

//@input Component.RenderMeshVisual particleRenderer
//@input float lifeTime = 2
//@input bool destroySelf = true
//@input bool playOnAwake = true
//@input string playFuncName
var particlePass = script.particleRenderer.mainPass;


particlePass.externalTime = true;
particlePass.instantSpawn = true;       
particlePass.externalSeed = Math.random();
var time = 0;
var isSpawning = script.playOnAwake;

script.api[script.playFuncName] = function() {
    isSpawning = true;
    script.getSceneObject().enabled = true;
};

script.createEvent("UpdateEvent").bind(function() {
    if (isSpawning) {       
        if (time < script.lifeTime) {
            time += getDeltaTime();
            particlePass.externalTimeInput = time;
        } else {
            if (script.destroySelf) {
                script.getSceneObject().destroy();
            }
        }
    }
});