// MoveToTargetHelper.js
// Version: 0.0.1
// Event: Lens Initialized
// Description: This helper script moves this object to a target object with adjustable speed

//@input SceneObject object
//@input SceneObject targetObject
//@input float moveSpeed = 1
//@input float moveDelay = 0.5

//@input bool disableAfterMove
//@input float disableDelayTime = 1

var transform = script.object.getTransform();


var startMoving = false;
var moveT = 0;
script.api.onResponse = function() {
    script.object.enabled = true;
    startMoving = true;
    resetEvent.reset(script.disableDelayTime);
    moveT = 0;
};

script.createEvent("UpdateEvent").bind(function() {
    
    if (!startMoving) {
        return;
    }
    if(moveT < script.moveDelay){
        moveT += getDeltaTime();
    }else{
        var targetPos = script.targetObject.getTransform().getWorldPosition();
        var targetRot = script.targetObject.getTransform().getWorldRotation();
        var newPos = vec3.lerp(transform.getWorldPosition(), targetPos, 0.2 * script.moveSpeed);
        var newRot = quat.lerp(transform.getWorldRotation(), targetRot, 0.2 * script.moveSpeed);
        transform.setWorldPosition(newPos);
        transform.setWorldRotation(newRot);
    }

});

var resetEvent = script.createEvent("DelayedCallbackEvent");
resetEvent.bind(reset);

function reset(){
    script.object.enabled = false;
    startMoving = false;
}